summaryrefslogtreecommitdiffhomepage
path: root/subr/ex_pkg_dispatch.subr
diff options
context:
space:
mode:
authorLucio Andrés Illanes Albornoz (arab, vxp) <lucio@lucioillanes.de>2017-12-05 02:05:54 +0000
committerLucio Andrés Illanes Albornoz (arab, vxp) <lucio@lucioillanes.de>2017-12-05 02:14:24 +0000
commit7a258a3ea5bda967a781a019685d78dca188789c (patch)
tree0353370058a2ddaef070870adaea9a15f182b269 /subr/ex_pkg_dispatch.subr
parent807f5fcd8b8d5e661986e16a271d94b165c53b59 (diff)
downloadmidipix_build-7a258a3ea5bda967a781a019685d78dca188789c.tar.bz2
midipix_build-7a258a3ea5bda967a781a019685d78dca188789c.tar.xz
subr/ex_pkg_dispatch.subr: maintain the count of jobs at its maximum at all times, whenever applicable.
Diffstat (limited to 'subr/ex_pkg_dispatch.subr')
-rw-r--r--subr/ex_pkg_dispatch.subr96
1 files changed, 56 insertions, 40 deletions
diff --git a/subr/ex_pkg_dispatch.subr b/subr/ex_pkg_dispatch.subr
index 4fbc2b17..4dee7863 100644
--- a/subr/ex_pkg_dispatch.subr
+++ b/subr/ex_pkg_dispatch.subr
@@ -6,10 +6,36 @@
# subshell(!). Instead, call ex_pkg_dispatch() and subsequently evaluate ${?}.
#
+exp_pkg_dispatch() {
+ local _pkg_name="${1}" _tgt_name="${2}" _restart_at="${3}" \
+ _dispatch_fn="${4}" _stderrout_path="${5}" _pipe_path="${6}" \
+ _njobs_vname="${7}" _pkg_name_uc;
+ _pkg_name_uc="$(ex_rtl_toupper "${_pkg_name}")";
+ if [ -n "$(ex_rtl_get_var_unsafe PKG_${_pkg_name_uc}_DISABLED)" ]; then
+ "${_dispatch_fn}" disabled_pkg "${_pkg_name}" "${_tgt_name}";
+ elif ex_pkg_state_test "${_pkg_name}" finish\
+ && [ -z "${_restart_at}" ]; then
+ "${_dispatch_fn}" skipped_pkg "${_pkg_name}" "${_tgt_name}";
+ else
+ _stderrout_path="${BUILD_WORKDIR}/${_pkg_name}_stderrout.log";
+ "${_dispatch_fn}" start_pkg "${_pkg_name}" "${_tgt_name}";
+ (set -o errexit -o noglob;
+ ex_pkg_env "${_pkg_name}" "${_tgt_name}" "${_restart_at}";
+ trap "if [ \${?} -eq 0 ]; then \
+ echo \"done ${_pkg_name} ${_tgt_name}\" >&3; \
+ else \
+ echo \"fail ${_pkg_name} ${_tgt_name}\" >&3; \
+ fi;" EXIT HUP INT TERM USR1 USR2;
+ ex_pkg_exec "${_pkg_name}" "${_tgt_name}" "${_restart_at}" \
+ "${_dispatch_fn}";) 1>"${_stderrout_path}" 2>&1 3>"${_pipe_path}" &
+ : $((${_njobs_vname}+=1));
+ fi;
+};
+
ex_pkg_dispatch() {
- local _tgt_name="${1}" _restart="${2}" _restart_at="${3}" \
- _dispatch_fn="${4}" _tgt_name_uc \
- _pkg_names _njob _njobs _njobs_max _pkg_name _pkg_name_uc \
+ local _tgt_name="${1}" _restart="${2}" _restart_at="${3}" \
+ _dispatch_fn="${4}" _tgt_name_uc \
+ _pkg_names _njob _njobs _njobs_max \
_pipe_path _stderrout_path _pipe_msg _script_rc;
ex_rtl_fileop mkdir "${BUILD_WORKDIR}";
_pipe_path="${BUILD_WORKDIR}/build.fifo";
@@ -20,60 +46,50 @@ ex_pkg_dispatch() {
&& [ "${_restart}" != ALL ]; then
_pkg_names="$(ex_rtl_lfilter "${_pkg_names}" "${_restart}")";
fi;
+ if [ "$(ex_rtl_get_var_unsafe ${_tgt_name_uc}_PARALLELISE)" = 1 ]; then
+ _njobs_max="${DEFAULT_BUILD_CPUS}";
+ else
+ _njobs_max=1;
+ fi;
set -- ${_pkg_names};
while [ ${#} -gt 0 ]; do
_script_rc=0; _njobs=0;
- if [ "$(ex_rtl_get_var_unsafe ${_tgt_name_uc}_PARALLELISE)" = 1 ]; then
- _njobs_max="${DEFAULT_BUILD_CPUS}";
- else
- _njobs_max=1;
- fi;
ex_rtl_fileop mkfifo "${_pipe_path}";
- for _njob in $(seq 1 ${_njobs_max}); do
- if [ ${#} -eq 0 ]; then
- break;
- else
- _pkg_name="${1}"; shift;
- _pkg_name_uc="$(ex_rtl_toupper "${_pkg_name}")";
- fi;
- if [ -n "$(ex_rtl_get_var_unsafe PKG_${_pkg_name_uc}_DISABLED)" ]; then
- "${_dispatch_fn}" disabled_pkg "${_pkg_name}" "${_tgt_name}";
- continue;
- elif ex_pkg_state_test "${_pkg_name}" finish\
- && [ -z "${_restart_at}" ]; then
- "${_dispatch_fn}" skipped_pkg "${_pkg_name}" "${_tgt_name}";
- continue;
- else
- _stderrout_path="${BUILD_WORKDIR}/${_pkg_name}_stderrout.log";
- "${_dispatch_fn}" start_pkg "${_pkg_name}" "${_tgt_name}";
- fi;
- (set -o errexit -o noglob;
- ex_pkg_env "${_pkg_name}" "${_tgt_name}" "${_restart_at}";
- trap "if [ \${?} -eq 0 ]; then \
- echo \"done ${_pkg_name} ${_tgt_name}\" >&3; \
- else \
- echo \"fail ${_pkg_name} ${_tgt_name}\" >&3; \
- fi;" EXIT HUP INT TERM USR1 USR2;
- ex_pkg_exec "${_pkg_name}" "${_tgt_name}" "${_restart_at}" \
- "${_dispatch_fn}";) 1>"${_stderrout_path}" 2>&1 3>"${_pipe_path}" &
- : $((_njobs+=1));
- done;
+ exp_pkg_dispatch "${1}" "${_tgt_name}" \
+ "${_restart_at}" "${_dispatch_fn}" \
+ "${_stderrout_path}" "${_pipe_path}" \
+ _njobs; shift;
if [ "${_njobs:-0}" -gt 0 ]; then
while read _pipe_msg; do
case "${_pipe_msg%% *}" in
done) "${_dispatch_fn}" finish_pkg ${_pipe_msg#done };
- [ $((_njobs-=1)) -eq 0 ] && break; ;;
+ : $((_njobs-=1));
+ for _njob in $(seq 1 $((${_njobs_max}-${_njobs}))); do
+ if [ ${#} -eq 0 ]; then
+ break;
+ else
+ exp_pkg_dispatch "${1}" "${_tgt_name}" \
+ "${_restart_at}" "${_dispatch_fn}" \
+ "${_stderrout_path}" "${_pipe_path}" \
+ _njobs; shift;
+ fi;
+ done;
+ if [ "${_njobs:-0}" -eq 0 ]; then
+ break;
+ fi; ;;
fail) _script_rc=1;
"${_dispatch_fn}" fail_pkg ${_pipe_msg#fail };
[ $((_njobs-=1)) -eq 0 ] && break; ;;
step) "${_dispatch_fn}" step_pkg ${_pipe_msg#step };
esac; done <"${_pipe_path}";
if [ "${_script_rc:-1}" -eq 1 ]; then
- ex_rtl_fileop rm "${_pipe_path}";
- return 1;
+ break;
fi;
fi;
ex_rtl_fileop rm "${_pipe_path}";
+ if [ "${_script_rc:-1}" -eq 1 ]; then
+ return "${_script_rc}";
+ fi;
done;
"${_dispatch_fn}" finish_target "" "${_tgt_name}";
};